﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.1
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	
	Private FlexGrid1 As FlexGrid
	Private xCalendarPickerDa As xCalendarPicker
	Private xCalendarPickerA As xCalendarPicker
	Private SD_LoadingIndicator1 As SD_LoadingIndicator
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root
	Root.LoadLayout("VediDocumenti")
	B4XPages.SetTitle(Me,"Scontrini - Visualizzazione")
	
	xCalendarPickerDa.Date=xCalendarPickerA.Date-DateTime.TicksPerDay*30
	FlexGrid1.SetColsNumber(6)
	FlexGrid1.ColsName = Array As String("ID","Data","Progressivo","Tipo","PDF","Annullo")
	FlexGrid1.ColsType = Array As Int(FlexGrid1.TypeString,FlexGrid1.TypeString,FlexGrid1.TypeString,FlexGrid1.TypeString,FlexGrid1.TypeString)
	FlexGrid1.ColsWidth = Array As Int(100dip,150dip,Max(250dip,Root.Width-540dip),80dip,80dip,80dip)
End Sub

Private Sub B4XPage_Appear
	SD_LoadingIndicator1.Hide
End Sub

Private Sub B4XPage_Resize (Width As Int, Height As Int)
	FlexGrid1.ColsWidth = Array As Int(100dip,150dip,Max(250dip,Root.Width-540dip),80dip,80dip,80dip)
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.
Private Sub ButtonCerca_Click
	Dim fc As fecs = B4XPages.MainPage.FC
	
	SD_LoadingIndicator1.Show
	FlexGrid1.ClearRows
	FlexGrid1.SetColCustomize(4,xui.Color_White,xui.Color_Red,xui.CreateFontAwesome(16))
	Wait For (fc.TrovaDocumenti(xCalendarPickerDa.Date,xCalendarPickerA.Date)) complete (ListDoc As List)
	
	For Each M As Map In ListDoc
		If "A"<>M.Get("annulli") And "V"=M.Get("tipoOperazione") Then 
			FlexGrid1.AddRow(Array As Object(M.Get("idtrx"),M.Get("data"),M.Get("numeroProgressivo"),M.Get("tipoOperazione"),Chr(0xF1C1),"Annulla"),False)
			FlexGrid1.SetCellCustomize(FlexGrid1.RowCount-1,5,xui.Color_White,xui.Color_RGB(0,148,255),xui.CreateDefaultBoldFont(14))
		Else 
			FlexGrid1.AddRow(Array As Object(M.Get("idtrx"),M.Get("data"),M.Get("numeroProgressivo"),M.Get("tipoOperazione"),Chr(0xF1C1),"-"),False)
		End If
	Next
	FlexGrid1.Invalidate
	
	SD_LoadingIndicator1.Hide
End Sub

Private Sub xCalendarPickerDa_Click
	If xCalendarPickerDa.Date>xCalendarPickerA.Date Then xCalendarPickerA.Date=xCalendarPickerDa.Date
End Sub

Private Sub xCalendarPickerA_Click
	If xCalendarPickerA.Date<xCalendarPickerDa.Date Then xCalendarPickerDa.Date=xCalendarPickerA.Date
End Sub

Private Sub FlexGrid1_CellClick(Row As Int, Col As Int)
	Dim idtrx As String = FlexGrid1.GetCellValue(Row,0)
	Dim fc As fecs = B4XPages.MainPage.FC
	
	If Col=4 Then ' ---------  produci PDF  --------------
		wait for (fc.DownloaddocumentoPDF(idtrx)) Complete(Success As Boolean)
		If Success Then 
			Dim sp As share_pdf
			sp.Initialize
			sp.Visualizza( xui.DefaultFolder,fc.Documento_FileNamePDF)
		Else
			Log("PDF errore")
		End If
	else if Col=5 Then ' ---------- ANNULLA DOCUMENTO -------------------
		If FlexGrid1.GetCellValue(Row,5)="Annulla" Then			
			Wait For (xui.Msgbox2Async($"Sicuro di annullare ${FlexGrid1.GetCellValue(Row,0)}?"$, "Annullo Documento", "Si", "", "No", Null)) Msgbox_Result (Result As Int)
			If Result = xui.DialogResponse_Positive Then
				wait for (fc.AnnullaDocumento(idtrx)) COMPLETE (Success As Boolean)
				If Success Then
					CaricaMerceInMagazzino
					wait for (fc.DownloaddocumentoPDF(fc.Documento_ID)) Complete(Success As Boolean)
					Log(File.Combine("ANNULLO pdf: " & xui.DefaultFolder ,fc.Documento_FileNamePDF))
					Dim sp As share_pdf
					sp.Initialize
					sp.Visualizza(xui.DefaultFolder,fc.Documento_FileNamePDF)
				Else
					xui.MsgboxAsync("Scontrino NON ANNULLATO","ATTENZIONE")
				End If
			End If
		End If
	Else
		' -----------------  Vedi DOCUMENTO   -------------------------
		Dim TipoDoc As String = FlexGrid1.GetCellValue(Row,3)
		If TipoDoc="V" Then TipoDoc="Vendita" Else TipoDoc="Annullo"
		
		Wait For (fc.RecuperaDocumento(idtrx)) COMPLETE (Document As Map)
		If Document.IsInitialized Then 
			Dim DC As Map = Document.Get("documentoCommerciale")
			Dim ec As List=DC.Get("elementiContabili")
			
			B4XPages.MainPage.VisualizzazioneGenerica.SetInfo("Documento " & TipoDoc) 
			Dim Fg As FlexGrid = B4XPages.MainPage.VisualizzazioneGenerica.Flex
			
			Fg.ClearRows
			Fg.SetColsNumber(7)
			Fg.ColsName=Array As String("ID","Descrizione","Prezzo","IVA","Qua","Totale","Omaggio")
			Fg.ColsWidth=Array As Int(100dip,200dip,100dip,80dip,80dip,100dip,80dip)
			For Each M As Map In ec
				Fg.AddRow(Array As Object(M.Get("idElementoContabile"),M.Get("descrizioneProdotto"),M.Get("prezzoUnitario"),M.Get("aliquotaIVA"),M.Get("quantita"),M.Get("totale"),IIf(M.Get("omaggio")="N","No","Si")),True)
			Next
			
			B4XPages.ShowPage("VisualizzazioneGenerica")
		End If
	End If
End Sub

Private Sub CaricaMerceInMagazzino
	'' ?????????????
End Sub