﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.1
@EndOfDesignText@
Sub Class_Globals
	Private xui As XUI
	#IF B4J
		Private fx As JFX
	#Else IF B4i
		Private di As DocumentInteraction
	#End If
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
End Sub

Public Sub Visualizza(Path As String, FileName As String)
	#IF B4A
		Dim in As Intent

		Wait For (xui.Msgbox2Async(FileName,"Documento PDF","Apri","","Condividi", Null)) Msgbox_Result (Result As Int)
		If Result = xui.DialogResponse_Positive Then 'apri
			in.Initialize(in.ACTION_VIEW,  CreateFileProviderUri(Path,FileName,Starter.shared))
			in.SetType("application/pdf")
			in.Flags = 1
			StartActivity(in)
		Else ' condividi
			in.Initialize(in.ACTION_SEND, "")
			in.SetType("application/pdf") 
			in.PutExtra("android.intent.extra.STREAM",  CreateFileProviderUri(Path,FileName,Starter.shared))
			in.Flags = 1
			StartActivity(in)
		End If
	#ELSE IF B4I
		di.Initialize("di", Path, FileName)
		di.OpenFile(B4XPages.GetNativeParent(B4XPages.GetManager.GetTopPage.B4XPage).RootPanel)
	#ELSE IF b4j
		Wait For (xui.Msgbox2Async(FileName,"Documento PDF","Apri","","Salva", Null)) Msgbox_Result (Result As Int)
		If Result = xui.DialogResponse_Positive Then 'apri
			fx.ShowExternalDocument(File.GetUri(Path, FileName))
		Else ' salva
			xui.SetDataFolder("fec")
			File.MakeDir(xui.DefaultFolder,"PDF")
			Dim FC As FileChooser
			FC.Initialize
			FC.InitialDirectory = File.Combine(xui.DefaultFolder,"PDF")
			FC.InitialFileName = FileName
			FC.Title = "Selezione il percorso dove salvare il file"
			FC.SetExtensionFilter("PDF", Array As String("*.PDF"))
			Dim Choix As String = FC.ShowSave(B4XPages.GetNativeParent(B4XPages.MainPage))
		
			If Choix <> "" Then
				File.Copy(xui.DefaultFolder,FileName,"",Choix)
			End If
		End If
	#End If
End Sub

#if b4a

Sub CreateFileProviderUri (Dir As String, FileName As String, shared As String) As Object  'ignore
	Dim FileProvider As JavaObject
	Dim context As JavaObject
	context.InitializeContext
	
	File.Copy(Dir, FileName, shared, FileName)
	FileProvider.InitializeStatic("android.support.v4.content.FileProvider")
	Dim f As JavaObject
	f.InitializeNewInstance("java.io.File", Array(shared, FileName))
	Return FileProvider.RunMethod("getUriForFile", Array(context, Application.PackageName & ".provider", f))
End Sub

#End If