﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.1
@EndOfDesignText@
#Event: ValueChanged (Index As Int, Value As String)

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
	
	#IF B4J
	Private SceltaBox As ComboBox
	#ELSE IF B4A
	Private SceltaBox As Spinner
	#ELSE IF B4I
	Private SceltaBox As Picker	
	#End If
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	#if B4J
	SceltaBox.Initialize("SceltaBox")
	SceltaBox.Items.Clear
	#ELSE IF B4A
	SceltaBox.Initialize("SceltaBox")
	SceltaBox.Clear
	#ELSE IF B4I
	SceltaBox.Initialize("SceltaBox")
	#End If
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
    Tag = mBase.Tag
    mBase.Tag = Me 
		
	#if B4J
	SceltaBox.Initialize("SceltaBox")
	SceltaBox.Items.Clear
	#ELSE IF B4A
	SceltaBox.Initialize("SceltaBox")
	SceltaBox.Clear
	#ELSE IF B4I
	SceltaBox.Initialize("SceltaBox")
	#End If
	
	mBase.AddView(SceltaBox,0,0,mBase.Width,mBase.Height)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	#IF B4J
	SceltaBox.prefWidth=Width
	SceltaBox.prefHeight=Height
	#ELSE
  	SceltaBox.Width=Width
  	SceltaBox.Height=Height
	#End If
End Sub

Public Sub Clear
	#if B4J
	SceltaBox.Items.Clear
	#ELSE IF B4A
	SceltaBox.Clear
	#ELSE IF B4I
	SceltaBox.SetItems(0,array as String())
	#End If
End Sub

Public Sub RequestFocus
	#if B4J
	SceltaBox.RequestFocus
	#ELSE IF B4A
	SceltaBox.RequestFocus
	#ELSE IF B4I
	SceltaBox.ResignFocus
	#End If
End Sub

Public Sub SetAll(L As List)
	#if B4J
	SceltaBox.Items.Clear
	SceltaBox.Items.AddAll(L)
	#ELSE IF B4A
	SceltaBox.Clear
	SceltaBox.AddAll(L)
	#ELSE IF B4I
	SceltaBox.SetItems(0,L)
	#End If
End Sub

Public Sub setSelectedIndex(Index As Int)
	#if B4J or B4A
	SceltaBox.SelectedIndex=Index
	#ELSE IF B4I
	SceltaBox.SelectRow(0,Index,False)
	#End If
End Sub

Public Sub getSelectedIndex As Int
	#if B4J or B4A
	Return SceltaBox.SelectedIndex
	#ELSE IF B4I
	Return SceltaBox.GetSelectedRow(0)
	#End If
End Sub

Public Sub getSelectedItem As String
	#if B4J
	Return SceltaBox.Items.Get(SceltaBox.SelectedIndex)
	#ELSE IF B4A
	Return SceltaBox.SelectedItem
	#ELSE IF B4I
	Return SceltaBox.GetSelectedItem(0)
	#End If
End Sub


#IF B4J

Private Sub SceltaBox_ValueChanged (Value As Object)
	If SubExists(mCallBack,mEventName & "_ValueChanged") Then CallSub3(mCallBack,mEventName & "_ValueChanged",SceltaBox.SelectedIndex,Value)
End Sub

#ELSE IF B4A

Private Sub SceltaBox_ItemClick (Position As Int, Value As Object)
	If SubExists(mCallBack,mEventName & "_ValueChanged") Then CallSub3(mCallBack,mEventName & "_ValueChanged",Position,Value)
End Sub

#ELSE IF b4i

Private Sub SceltaBox_ItemSelected (Column As Int, Row As Int)
	If SubExists(mCallBack,mEventName & "_ValueChanged",2) Then CallSub3(mCallBack,mEventName & "_ValueChanged",Row, SceltaBox.GetSelectedItem(0))
End Sub

#End If