﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.1
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	
	Private FlexGrid1 As FlexGrid
	Private xCalendarPickerDa As xCalendarPicker
	Private xCalendarPickerA As xCalendarPicker
	Private LabelInfo As B4XView
	Private SD_LoadingIndicator1 As SD_LoadingIndicator
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root
	Root.LoadLayout("chiusure")
	B4XPages.SetTitle(Me,"Chiusure e Aggregati")
	
	xCalendarPickerDa.Date=xCalendarPickerA.Date-DateTime.TicksPerDay*30
	FlexGrid1.ColsName = Array As String("ID","Data","Progressivo","Tipo")
	FlexGrid1.ColsType = Array As Int(FlexGrid1.TypeString,FlexGrid1.TypeString,FlexGrid1.TypeString,FlexGrid1.TypeString)
	FlexGrid1.ColsAlignment=Array As String("CENTER","CENTER","RIGHT","RIGHT")
End Sub

Private Sub B4XPage_Appear
	SD_LoadingIndicator1.Hide
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.
Private Sub ButtonCerca_Click
	Dim fc As fecs = B4XPages.MainPage.FC
	
	LabelInfo.Text="Aggregati Scontrini Online"
	SD_LoadingIndicator1.Show
	FlexGrid1.ClearRows
	FlexGrid1.ColsWidth = Array As Int(Max(120dip,Root.Width-400dip),120dip,120dip,120dip)
	FlexGrid1.ColsAlignment=Array As String("CENTER","CENTER","RIGHT","RIGHT")
	
	Wait For (fc.TrovaChiusure(xCalendarPickerDa.Date,xCalendarPickerA.Date)) complete (ListDoc As List)
	
	FlexGrid1.ColsName = Array As String("ID","Data","Annulato","Totale")
	If ListDoc.IsInitialized Then
		For Each M As Map In ListDoc
			Dim A As Double = M.Get("importoAnnullato").As(String).replace("+","").Replace(",",".")
			Dim D As Double = M.Get("ammontareComplessivo").As(String).Replace("+","").Replace(",",".")
			FlexGrid1.AddRow(Array As Object(M.Get("id"),ToDate(M.Get("dataEmissione")),NumberFormat2(a,1,4,2,False)& " ",NumberFormat2(d,1,4,2,False)& "  "),False)
		Next
	End If

	FlexGrid1.Invalidate
	SD_LoadingIndicator1.Hide
End Sub

Private Sub ButtonCercaRT_Click
	Dim fc As fecs = B4XPages.MainPage.FC
	
	LabelInfo.Text="Chiusure giornaliere RT"
	SD_LoadingIndicator1.Show
	FlexGrid1.ClearRows
	FlexGrid1.ColsWidth = Array As Int(120dip,Max(150dip,Root.Width-430dip),150dip,120dip)

	Wait For (fc.TrovaChiusureRT(xCalendarPickerDa.Date,xCalendarPickerA.Date)) complete (ListDoc As List)
	FlexGrid1.ColsName = Array As String("ID","Data","Matricola","totale")
	For Each M As Map In ListDoc
		Dim D As Double = M.Get("ammontareTotale").As(String).Replace("+","").Replace(",",".")
		FlexGrid1.AddRow(Array As Object(M.Get("idInvio"),M.Get("timeRilevazione").As(String).Replace("T"," "),M.Get("matricolaDispositivo")& " ", NumberFormat2(d,1,4,2,False) & "  "),False)
	Next
	FlexGrid1.Invalidate
	SD_LoadingIndicator1.Hide
End Sub

Private Sub xCalendarPickerDa_Click
	If xCalendarPickerDa.Date>xCalendarPickerA.Date Then xCalendarPickerA.Date=xCalendarPickerDa.Date
End Sub

Private Sub xCalendarPickerA_Click
	If xCalendarPickerA.Date<xCalendarPickerDa.Date Then xCalendarPickerDa.Date=xCalendarPickerA.Date
End Sub

Private Sub ToDate(D As Long) As String
	Return $"$2.0{DateTime.GetDayOfMonth(D)}-$2.0{DateTime.GetMonth(D)}-${DateTime.GetYear(D)}"$
End Sub