﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.1
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	
	Private FlexGrid1 As FlexGrid
	Private xCalendarPickerDa As xCalendarPicker
	Private xCalendarPickerA As xCalendarPicker
	Private SD_LoadingIndicator1 As SD_LoadingIndicator
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	xui.SetDataFolder("fec")
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root
	Root.LoadLayout("VediDocumenti")
	B4XPages.SetTitle(Me,"Fatture Ricevute")
	
	xCalendarPickerDa.Date=xCalendarPickerA.Date-DateTime.TicksPerDay*30
	FlexGrid1.SetColsNumber(9)
	FlexGrid1.ColsName=Array As String("TipoInvio","IdFattura","N.","Denominazione","PIVA","Data","Importo","Stato","XML")
	FlexGrid1.ColsAlignment = Array As String("CENTER","LEFT","CENTER","CENTER","RIGHT","CENTER","CENTER")
	FlexGrid1.ColsWidth = Array As Int(0dip,0dip,150dip,Max(250dip,Root1.Width-680dip),110dip,100dip,100dip,100dip, 80dip)
End Sub

Private Sub B4XPage_Appear
	SD_LoadingIndicator1.Hide
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.
Private Sub ButtonCerca_Click
	Dim fc As fecs = B4XPages.MainPage.FC
	
	SD_LoadingIndicator1.Show
	FlexGrid1.ClearRows
	FlexGrid1.SetColCustomize(8,xui.Color_White,xui.Color_RGB(38,127,0),xui.CreateDefaultFont(14))
	Wait For (fc.readFattureRicevute(xCalendarPickerDa.Date,xCalendarPickerA.Date,False,xui.DefaultFolder)) COMPLETE (Success As Boolean)
	
	If Success Then 
		Dim Ftr As JSONParser
		Ftr.Initialize(File.ReadString(xui.DefaultFolder, "lista-fatture.json"))
		Dim Fatture As List = Ftr.NextObject.Get("fatture")
		
		For Each f As Map In Fatture
			Dim fileDownload As Map = f.Get("fileDownload")
			Dim Importo As Double = f.Get("imponibile").As(String).Replace("+","").Replace(",",".")
			Importo=Importo+f.Get("imposta").As(String).Replace("+","").Replace(",",".")
			
			FlexGrid1.AddRow(Array As Object(f.Get("tipoInvio"),f.Get("idFattura"),f.Get("numeroFattura"),f.Get("denominazioneEmittente"),f.Get("pivaEmittente"),f.Get("dataFattura"),$"€. ${NumberFormat2(Importo,1,2,2,False)}  "$,fileDownload.Get("statoFile"),"XML"),False)
		Next
	End If

	FlexGrid1.Invalidate
	SD_LoadingIndicator1.Hide
End Sub

Private Sub xCalendarPickerDa_Click
	If xCalendarPickerDa.Date>xCalendarPickerA.Date Then xCalendarPickerA.Date=xCalendarPickerDa.Date
End Sub

Private Sub xCalendarPickerA_Click
	If xCalendarPickerA.Date<xCalendarPickerDa.Date Then xCalendarPickerDa.Date=xCalendarPickerA.Date
End Sub

Private Sub FlexGrid1_CellClick(Row As Int, Col As Int)
	If Col=8 Then 
		' Download fattura
		Dim fc As fecs = B4XPages.MainPage.FC
		Dim tipoInvio As String = FlexGrid1.GetCellValue(Row,0)
		Dim idFattura As String = FlexGrid1.GetCellValue(Row,1)
		fc.DownloadFattureRicevuteXML(xui.DefaultFolder,tipoInvio,idFattura)
		
		' Trovi il file nella cartella xui.DefaultFolder
		' nomefile = tipoInvio & idFattura
		' Ci vuole un lettore specifico per XML delel fatture oppure usare la libreria SD_p7m
		' https://www.b4x.com/android/forum/threads/b4x-sd-p7m-fattura-elettronica.105756/
	End If
End Sub