﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.3
@EndOfDesignText@
#Event: Click
#DesignerProperty: Key: TextColor, DisplayName: Text Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: TExt Color
#DesignerProperty: Key: TextSize, DisplayName: Text Size for not Square, FieldType: int, DefaultValue: 16, Description: Size for TextLabel if not Square
#DesignerProperty: Key: Color, DisplayName: Backgrond Color, FieldType: Color, DefaultValue: 0xFF009688, Description: Backgrond Color
#DesignerProperty: Key: CornerColor, DisplayName: Corner Color, FieldType: Color, DefaultValue: 0xFF000000, Description: Corner Color
#DesignerProperty: Key: CornerRadius, DisplayName: Corner radius , FieldType: int, DefaultValue: 10, Description: Corner radius size for TextLabel if not Square
#DesignerProperty: Key: Title, DisplayName: Title windows, FieldType: String, DefaultValue: Select date, Description: Backgrond Color
#DesignerProperty: Key: Square, DisplayName: Square form, FieldType: boolean, DefaultValue: True, Description: Square form
#DesignerProperty: Key: Now, DisplayName: Date Now, FieldType: Boolean, DefaultValue: True, Descriptio: Start date from Now
#DesignerProperty: Key: DayOfMounth, DisplayName: Day of Mounth, FieldType: int, DefaultValue: 1, Description: Day of Mounth
#DesignerProperty: Key: Mounth, DisplayName: Mounth, FieldType: int, DefaultValue: 8, Description: Mounth
#DesignerProperty: Key: Year, DisplayName: Year, FieldType: int, DefaultValue: 2018, Description: Year

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	
	Public Color As Int 
	Public TextColor As Int
	Public CornerColor As Int = 0xFF000000
	Public CornerRadius As Int = 10
	Public TextSize As Int = 16
	Public Title As String = ""
	Public Square As Boolean = True
	Public Tag As Object
	
	Private PanelShow As B4XView 
	Private PanelExternal As B4XView 
	Private CanPanelExternal As B4XCanvas
	Private MyAct As B4XView
	Private Cale As B4XView
	Private Testa As B4XView
	
	Private DateSelect As Long = 0
	Private DateRet As Long = 0
	Private Ret As Int = 0
	
	Private ButtonOk As B4XView
	Private ButtoCancel As B4XView
	Private LabelNow As B4XView
	Private LDay As Label
	Private LYear As Label
	Private LMounth As B4XView
	
	' Bottoni avanzamento data
	Private PulsPrevY As B4XView 
	Private PulsNextY As B4XView
	Private PulsPrevM As B4XView
	Private PulsNextM As B4XView
	
End Sub

Public Sub Initialize (CallBack As Object, EventName As String)
	mEventName = EventName
	mCallBack = CallBack
	
	TextColor = xui.Color_White
	Color = xui.Color_RGB(0,150,136)
	
	PanelShow=xui.CreatePanel("PanelShow")
	PanelExternal=xui.CreatePanel("PanelExternal")
	Cale=xui.CreatePanel("Cale")
	Testa=xui.CreatePanel("Testa")

'	Dim MoPrev As Button
'	Dim MoNext As Button
'	Dim YPrev As Button
'	Dim YNext As Button
	#IF B4I
		Dim BO As  Button
		BO.Initialize("ButtonOk",BO.STYLE_SYSTEM)
		BO.CustomLabel.TextAlignment=BO.CustomLabel.ALIGNMENT_CENTER
		Dim BC As  Button
		BC.Initialize("ButtonCancel",BC.STYLE_SYSTEM)
'		MoPrev.Initialize("PrevM",Prev.STYLE_SYSTEM)
'		MoNext.Initialize("NextM",Nxt.STYLE_SYSTEM)
'		YPrev.Initialize("PrevY",YPrev.STYLE_SYSTEM)
'		YNext.Initialize("NextY",YNext.STYLE_SYSTEM)
	#ELSE
		Dim BO As  Button
		BO.Initialize("ButtonOk")
		Dim BC As  Button
		BC.Initialize("ButtonCancel")
'		MoPrev.Initialize("PrevM")
'		MoNext.Initialize("NextM")
'		YPrev.Initialize("PrevY")
'		YNext.Initialize("NextY")
	#END IF
	ButtonOk=BO
	ButtoCancel=BC
		
'	'Mounth
'	CornerButton(MoPrev,xui.Color_LightGray)
'	PulsPrevM= MoPrev
'	CornerButton(MoNext,xui.Color_LightGray)
'	PulsNextM = MoNext
'	
'	' Year
'	CornerButton(YPrev,xui.Color_LightGray)
'	PulsPrevY=YPrev
'	PulsNextY = YNext
'	CornerButton(YNext,xui.Color_LightGray)

	PulsPrevM=CornerPanel("PrevM",xui.Color_LightGray,True)
	PulsPrevY=CornerPanel("PrevY",xui.Color_LightGray,True)
	PulsNextM=CornerPanel("NextM",xui.Color_LightGray,False)
	PulsNextY=CornerPanel("NextY",xui.Color_LightGray,False)
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	'Dim clr As Int = xui.PaintOrColorToColor(Props.Get("TextColor")) 'Example of getting a color value from Props
	Dim D,M,Y As Int
	
	mBase = Base
	mBase.Tag=Me
	mBase.Color=xui.Color_Transparent
	
	' Find Activity
	Dim Prec As B4XView
	MyAct = mBase
	Try
		MyAct=mBase
		Do While MyAct.Parent Is B4XView
			Prec=MyAct
			MyAct=MyAct.Parent
		Loop
	Catch
		Log(LastException)
	End Try
	If xui.IsB4i Then MyAct=Prec
	
	' Initialize Main Panel
	mBase.AddView(PanelExternal,0dip,0dip,mBase.Width,mBase.Height)
	CanPanelExternal.Initialize(PanelExternal)
	
	' Read Parameter
	If Props.ContainsKey("TextColor") Then TextColor=xui.PaintOrColorToColor(Props.Get("TextColor"))
	If Props.ContainsKey("TextSize") Then TextSize=Props.Get("TextSize")
	If Props.ContainsKey("Color") Then Color=xui.PaintOrColorToColor(Props.Get("Color"))
	If Props.ContainsKey("CornerColor") Then CornerColor=xui.PaintOrColorToColor(Props.Get("CornerColor"))
	If Props.ContainsKey("CornerRadius") Then CornerRadius=Props.Get("CornerRadius")
	If Props.ContainsKey("DayOfMounth") Then d=Props.Get("DayOfMounth")
	If Props.ContainsKey("Mounth") Then m=Props.Get("Mounth")
	If Props.ContainsKey("Year") Then y=Props.Get("Year")
	If Props.ContainsKey("Title") Then Title=Props.Get("Title")
	If Props.ContainsKey("Square") Then Square=Props.Get("Square")
	
	ButtonOk.Color=xui.Color_Transparent
	ButtonOk.TextColor=TextColor
	ButtonOk.Font=xui.CreateDefaultBoldFont(14)
	ButtonOk.Text="OK"
	'ButtonOk.SetTextAlignment("CENTER","CENTER")

	ButtoCancel.Color=xui.Color_Transparent
	ButtoCancel.TextColor=TextColor
	ButtoCancel.Font=xui.CreateDefaultBoldFont(14)
	ButtoCancel.Text="Cancel"
	
	If Props.ContainsKey("Now") Then
		If Props.Get("Now")=True Then
			DateSelect=DateTime.Now
			D=DateTime.GetDayOfMonth(DateSelect)
			M=DateTime.GetMonth(DateSelect)
			Y=DateTime.GetYear(DateSelect)
		Else
			DateTime.DateFormat="MM/dd/yyyyy"
			DateSelect=DateTime.DateParse(m & "/" & d & "/" & y)
		End If
	End If
	
	DateTime.DateFormat="MM/dd/yyyyy"
	DateSelect=DateTime.DateParse(m & "/" & d & "/" & y)
	DateRet=DateSelect
	
	If Square Then
		SetExtDate(D,M,Y)
	Else
		SetTextDate(D,M,Y)
	End If
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
  
End Sub

#Region Public Method

Public Sub ReSetEvent(Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

Public Sub BringToFront
	mBase.BringToFront
End Sub

Public Sub GetAllViewsRecursive As List
	Return mBase.GetAllViewsRecursive
End Sub

#IF B4J
	Public Sub GetBase As Pane
		Return mBase
	End Sub
#ELSE
	Public Sub GetBase As Panel
		Return mBase
	End Sub
#End If

Public Sub setEnable(B As Boolean)
	mBase.Enabled=B
End Sub

Public Sub getEnable As Boolean
	Return mBase.Enabled
End Sub

Public Sub GetView(Index As Int) As B4XView
	Return mBase.GetView(Index)
End Sub

Public Sub setHeight(B As Int)
	mBase.Height=B
End Sub
Public Sub setLeft(B As Int)
	mBase.Left=B
End Sub

Public Sub getLeft As Int
	Return mBase.Left
End Sub

Public Sub getHeight As Int
	Return mBase.Height
End Sub

Public Sub RemoveViewFromParent
	mBase.RemoveViewFromParent
End Sub

Public Sub RequestFocus
	mBase.RequestFocus
End Sub

Public Sub SendToBack
	mBase.SendToBack
End Sub

Public Sub Snapshot As B4XView
	Return mBase.Snapshot
End Sub

Public Sub setTop(B As Int)
	mBase.Top=B
End Sub

Public Sub getTop As Int
	Return mBase.Top
End Sub

Public Sub setVisible(B As Boolean)
	mBase.Visible=B
End Sub

Public Sub getVisible As Boolean
	Return mBase.Visible
End Sub

Public Sub setWidth(B As Int)
	mBase.Width=B
End Sub

Public Sub getWidth As Int
	Return mBase.Width
End Sub

Public Sub getDate As Long
	Return DateSelect
End Sub

Public Sub setDate(Date As Long)
	Dim D,M,Y As Int
	
	D=DateTime.GetDayOfMonth(Date)
	M=DateTime.GetMonth(Date)
	Y=DateTime.GetYear(Date)
	
	DateTime.DateFormat="MM/dd/yyyy"
	DateSelect=DateTime.DateParse(m & "/" & d & "/" & y)

	If Square Then
		SetExtDate(D,M,Y)
	Else
		SetTextDate(D,M,Y)
	End If
End Sub

#End Region

#region InputDialog

#IF B4J
Private Sub PanelExternal_MousePressed (EventData As MouseEvent)
	Ret=0
	Show
	If Ret=xui.DialogResponse_Positive Then setDate(DateSelect)
End Sub
#ELSE
	Private Sub PanelExternal_Click
		Ret=0
		Show
		If Ret=xui.DialogResponse_Positive Then setDate(DateSelect)
	End Sub
#END IF

private Sub FillCalendar
	Dim GDay,D,M,A,Y,X As Int
	Dim DateStart As Long

	Cale.RemoveAllViews
	'CALENDARIO
	d=DateTime.GetDayOfMonth(DateRet)
	m=DateTime.GetMonth(DateRet)
	a=DateTime.GetYear(DateRet)
	GDay=DateTime.GetDayOfWeek(DateRet)
	
	DateTime.DateFormat="MM/dd/yyy"
	DateStart=DateTime.DateParse(M & "/01/" & A)
	
	DateTime.DateFormat="MM/dd/yyy"
	GDay=DateTime.GetDayOfWeek(DateTime.DateParse(M & "/01/" & A))
	
	For i=0 To 6
		If i=0 Then
			Dim Lab As B4XView=CreaLabel("",NomeGiorno(i),xui.Color_Red,xui.Color_Transparent,14,True)
		Else
			Dim Lab As B4XView=CreaLabel("",NomeGiorno(i),xui.Color_Black,xui.Color_Transparent,14,True)
		End If
		Cale.AddView(Lab,i*40dip,0dip,40dip,40dip)
	Next
	
	Y=40dip
	X=(GDay-1)*40dip
	For i=1 To 31
		If DateTime.GetMonth(DateStart)=m Then
			If d=i And m=DateTime.GetMonth(DateSelect) Then
				Dim Lab As B4XView=CreaLabel("Giorno",i,TextColor,xui.Color_Transparent,14,True)
				LabelNow=Lab
			Else
				Dim Lab As B4XView=CreaLabel("Giorno",i,xui.Color_Black,xui.Color_Transparent,14,True)
			End If
			Lab.Tag=DateStart
			Cale.AddView(Lab,X,Y,40dip,40dip)
						
			GDay=GDay+1
			If GDay>7 Then
				GDay=1
				Y=Y+35dip
				X=0dip
			Else
				X=X+40dip
			End If

		End If
		DateStart=DateStart + DateTime.TicksPerDay
	Next
	
	'Button
	ButtonOk.RemoveViewFromParent
	ButtoCancel.RemoveViewFromParent
	
	Cale.AddView(ButtonOk,140dip,240dip,140dip,40dip)
	Cale.AddView(ButtoCancel,0dip,240dip,140dip,40dip)
	
	Corner(LabelNow,TextColor)
End Sub

private Sub FillTesta
	Dim ColorHeadText As Int = TextColor
	Testa.RemoveAllViews
	'TITOLO
	Testa.AddView(CreaLabel("",Title,xui.Color_White,xui.Color_ARGB(150,0,0,0),14,False),0dip,0dip,280dip,30dip)
	
	' Mounth
	LMounth=CreaLabel("",NomeMese(DateTime.GetMonth(DateRet)),ColorHeadText,xui.Color_Transparent,25,False)
	Testa.AddView(LMounth,0dip,30dip,280dip,60dip)
	
	PulsPrevM.RemoveViewFromParent
	Testa.AddView(PulsPrevM,0dip,35dip,40dip,40dip)
	
	PulsNextM.RemoveViewFromParent
	Testa.AddView(PulsNextM,240dip,35dip,40dip,40dip)
	
	'giorno
	LDay=CreaLabel("",DateTime.GetDayOfMonth(DateRet),ColorHeadText,xui.Color_Transparent,100,False)
	Testa.AddView(LDay,0dip,70dip,280dip,120dip)
	
	'Year
	LYear=CreaLabel("",DateTime.GetYear(DateRet),ColorHeadText,xui.Color_Transparent,30,False)
	Testa.AddView(LYear,0dip,190dip,280dip,40dip)
	
	'Prev Year
	PulsPrevY.RemoveViewFromParent
	Testa.AddView(PulsPrevY,0dip,190dip,40dip,40dip)
	
	'Next year
	PulsNextY.RemoveViewFromParent
	Testa.AddView(PulsNextY,240dip,190dip,40dip,40dip)
	
End Sub

Private Sub Show
	PanelShow.RemoveAllViews
	PanelShow.BringToFront
	#IF B4J
		Dim Tit As Int = 0 'ignore
		PanelShow.Color=xui.color_ARGB(200,255,255,255)
	#ELSE IF B4I
		Dim Tit As Int = GetDeviceLayoutValues.Height - 100%y
	#Else
		Dim Tit As Int = GetDeviceLayoutValues.Height - 100%y
		PanelShow.Color=xui.color_ARGB(200,0,0,0)
	#END IF
	
	Cale.SetColorAndBorder(Color,1dip,CornerColor,0dip)
	Testa.SetColorAndBorder(Color,1dip,CornerColor,0dip)
	
	DateRet=DateSelect
	FillCalendar
	FillTesta
		
	#IF B4J
	If MyAct.Height>MyAct.Width Then
	'verticale -250 +280 = 530
		PanelShow.AddView(Testa,(MyAct.Width/2)-140dip,(MyAct.Height/2)-265dip,280dip,250dip)
		PanelShow.AddView(Cale,(MyAct.Width/2)-140dip,(MyAct.Height/2)-15dip,280dip,280dip)
		MyAct.AddView(PanelShow,0dip,0dip,MyAct.Width,MyAct.Height)
	Else
	'orizzontale
		PanelShow.AddView(Testa,(MyAct.Width/2)-280dip,(MyAct.Height/2)-140dip,280dip,280dip)
		PanelShow.AddView(Cale,(MyAct.Width/2),(MyAct.Height/2)-140dip,280dip,280dip)
		MyAct.AddView(PanelShow,0dip,0dip,MyAct.Width,MyAct.Height)
	End If
	
	Do While Ret=0
		Sleep(50)
	Loop
	#ELSE IF B4A
	If 100%y>100%x Then
		'verticale -250 +280 = 530
		PanelShow.AddView(Testa,50%x-140dip,50%y-265dip,280dip,250dip)
		PanelShow.AddView(Cale,50%x-140dip,50%y-15dip,280dip,280dip)
		MyAct.AddView(PanelShow,0dip,0dip,100%x,100%y)
	Else
		'orizzontale
		PanelShow.AddView(Testa,50%x-280dip,50%y-140dip,280dip,280dip)
		PanelShow.AddView(Cale,50%x,50%y-140dip,280dip,280dip)
		MyAct.AddView(PanelShow,0dip,0dip,100%x,100%y)
	End If
	
	Do While Ret=0
		Sleep(50)
		If PanelShow.Width<>GetDeviceLayoutValues.Width  Then
			MyAct.Width=GetDeviceLayoutValues.Width
			MyAct.Height=GetDeviceLayoutValues.Height-Tit
			PanelShow.Width=GetDeviceLayoutValues.Width
			PanelShow.Height=GetDeviceLayoutValues.Height-Tit

			If PanelShow.Height>PanelShow.Width Then
				'verticale -250 +280 = 530
				Testa.Left=PanelShow.Width/2-140dip
				Testa.Top=PanelShow.Height/2-265dip
				Testa.Height=250dip
				Cale.Left=PanelShow.Width/2-140dip
				Cale.Top=PanelShow.Height/2-15dip
			Else
				'orizzontale
				Testa.Left=PanelShow.Width/2-280dip
				Testa.Top=PanelShow.Height/2-140dip
				Testa.Height=280dip
				Cale.Left=PanelShow.Width/2
				Cale.Top=PanelShow.Height/2-140dip
			End If
		End If
	Loop
	#ELSE IF B4I
	If MyAct.Height>MyAct.Width Then
		'verticale -250 +280 = 530
		PanelShow.AddView(Testa,(MyAct.Width/2)-140dip,(MyAct.Height/2)-265dip,280dip,250dip)
		PanelShow.AddView(Cale,(MyAct.Width/2)-140dip,(MyAct.Height/2)-15dip,280dip,280dip)
		MyAct.AddView(PanelShow,0dip,0dip,MyAct.Width,MyAct.Height)
	Else
		'orizzontale
		PanelShow.AddView(Testa,(MyAct.Width/2)-280dip,(MyAct.Height/2)-140dip,280dip,280dip)
		PanelShow.AddView(Cale,(MyAct.Width/2),(MyAct.Height/2)-140dip,280dip,280dip)
		MyAct.AddView(PanelShow,0dip,0dip,MyAct.Width,MyAct.Height)
	End If
	
	Do While Ret=0
		Sleep(50)
		If PanelShow.Width<>GetDeviceLayoutValues.Width  Then
			MyAct.Width=GetDeviceLayoutValues.Width
			MyAct.Height=GetDeviceLayoutValues.Height-Tit
			PanelShow.Width=GetDeviceLayoutValues.Width
			PanelShow.Height=GetDeviceLayoutValues.Height-Tit

			If PanelShow.Height>PanelShow.Width Then
				'verticale -250 +280 = 530
				Testa.Left=PanelShow.Width/2-140dip
				Testa.Top=PanelShow.Height/2-265dip
				Testa.Height=250dip
				Cale.Left=PanelShow.Width/2-140dip
				Cale.Top=PanelShow.Height/2-15dip
			Else
				'orizzontale
				Testa.Left=PanelShow.Width/2-280dip
				Testa.Top=PanelShow.Height/2-140dip
				Testa.Height=280dip
				Cale.Left=PanelShow.Width/2
				Cale.Top=PanelShow.Height/2-140dip
			End If
		End If
	Loop
	#End If
	
	PanelShow.RemoveViewFromParent
End Sub

#IF B4J
Private Sub Giorno_MouseClicked (EventData As MouseEvent)
	If LabelNow.IsInitialized Then
		LabelNow.SetColorAndBorder(xui.Color_Transparent,0dip,TextColor,0)
		LabelNow.TextColor=xui.Color_Black
	End If
	
	LabelNow=Sender
	Corner(LabelNow,TextColor)
	LabelNow.Textcolor=TextColor
	
	DateRet=LabelNow.Tag
	LDay.Text=LabelNow.Text
End Sub
#ELSE
private Sub Giorno_Click
	If LabelNow.IsInitialized Then 
		LabelNow.SetColorAndBorder(xui.Color_Transparent,0dip,TextColor,0)
		LabelNow.TextColor=xui.Color_Black
	End If
	
	LabelNow=Sender
	Corner(LabelNow,TextColor)
	LabelNow.Textcolor=TextColor
	
	DateRet=LabelNow.Tag
	LDay.Text=LabelNow.Text
End Sub
#End If

#End Region

#Region Button

#IF B4J
	Private Sub PrevM_MouseClicked (EventData As MouseEvent)
		PrevM_Click
	End Sub

	Private Sub NextM_MouseClicked (EventData As MouseEvent)
		NextM_Click
	End Sub

	Private Sub PrevY_MouseClicked (EventData As MouseEvent)
		PrevY_Click
	End Sub

	Private Sub NextY_MouseClicked (EventData As MouseEvent)
		Nexty_Click
	End Sub
#END IF

Private Sub PrevM_Click
	Dim D,M,A As Int
	
	d=DateTime.GetDayOfMonth(DateRet)
	m=DateTime.GetMonth(DateRet)
	a=DateTime.GetYear(DateRet)
	
	M=M-1
	If M=0 Then
		M=12
		a=a-1
	End If
	
	If (M=2)And(D>28) Then D=28
	If (D>30) And (M=4 Or M=6 Or M=9 Or M=11) Then D=30
	
	DateTime.DateFormat="MM/dd/yyyy"
	DateRet=DateTime.DateParse(m & "/" & d & "/" & a)
	FillCalendar
	LMounth.Text=NomeMese(M)
	LYear.Text=a
	LDay.Text=d
End Sub

Private Sub NextM_Click
	Dim D,M,A As Int
	
	d=DateTime.GetDayOfMonth(DateRet)
	m=DateTime.GetMonth(DateRet)
	a=DateTime.GetYear(DateRet)
	
	M=M+1
	If M=13 Then
		M=1
		a=a+1
	End If
	
	If (M=2)And(D>28) Then D=28
	If (D>30) And (M=4 Or M=6 Or M=9 Or M=11) Then D=30
	
	DateTime.DateFormat="MM/dd/yyyy"
	DateRet=DateTime.DateParse(m & "/" & d & "/" & a)
	FillCalendar
	LMounth.Text=NomeMese(M)
	LYear.Text=a
	LDay.Text=d
End Sub

Private Sub PrevY_Click
	Dim D,M,A As Int
	
	d=DateTime.GetDayOfMonth(DateRet)
	m=DateTime.GetMonth(DateRet)
	a=DateTime.GetYear(DateRet)
	
	a=a-1
		
	If (M=2)And(D>28) Then D=28
	If (D>30) And (M=4 Or M=6 Or M=9 Or M=11) Then D=30
	
	DateTime.DateFormat="MM/dd/yyyy"
	DateRet=DateTime.DateParse(m & "/" & d & "/" & a)
	FillCalendar
	LYear.Text=a
	LDay.Text=d
End Sub

Private Sub Nexty_Click
	Dim D,M,A As Int
	
	d=DateTime.GetDayOfMonth(DateRet)
	m=DateTime.GetMonth(DateRet)
	a=DateTime.GetYear(DateRet)
	
	a=a+1
		
	If (M=2)And(D>28) Then D=28
	If (D>30) And (M=4 Or M=6 Or M=9 Or M=11) Then D=30
	
	DateTime.DateFormat="MM/dd/yyyy"
	DateRet=DateTime.DateParse(m & "/" & d & "/" & a)
	FillCalendar
	LYear.Text=a
	LDay.Text=d
End Sub

private Sub ButtonOk_Click
	setDate(DateRet)
	Ret=xui.DialogResponse_Positive
	#IF B4I
		If SubExists(mCallBack,mEventName & "_Click",0) Then CallSub(mCallBack,mEventName & "_Click")
	#ELSE
		If SubExists(mCallBack,mEventName & "_Click") Then CallSub(mCallBack,mEventName & "_Click")
	#End If
End Sub

private Sub ButtonCancel_Click
	Ret=xui.DialogResponse_Negative
End Sub

#End Region

#Region Funzioni

Private Sub Corner(V As B4XView,Clr As Int)
	V.SetColorAndBorder(V.Color,1dip,Clr,V.Width/2)
'	#IF B4A
'		Dim Can As B4XCanvas
'		
'		Can.Initialize(v)
'		Dim P As B4XPath
'		P.InitializeRoundedRect(Can.TargetRect,10dip)
'		Can.DrawPath(P,Clr,True,1)
'		Can.Invalidate
'		Can.Release
'	#ELSE IF B4J
'		Dim fx As JFX
'		CSSUtils.SetBackgroundColor(v,fx.Colors.From32Bit(Clr))
'	#ELSE IF B4I
'		Dim L As Label = V
'		L.Color=Clr
'	#END IF
End Sub

Private Sub CornerPanel(Event As String, Clr As Int, Left As Boolean) As B4XView
	Dim P As B4XView = xui.CreatePanel(Event)
	Dim Can As B4XCanvas
	
	P.SetLayoutAnimated(0,0,0,40dip,40dip)
	Can.Initialize(P)
	Can.DrawCircle(20dip,20dip,20dip,Clr,True,1)
	
	Dim Path As B4XPath
	If Left Then 
		Path.Initialize(25dip,10dip)
		Path.LineTo(25dip,30dip)
		Path.LineTo(10dip,20dip) 
	Else 
		Path.Initialize(15dip,10dip)
		Path.LineTo(15dip,30dip)
		Path.LineTo(30dip,20dip)
	End If
	Can.DrawPath(Path,xui.Color_Black,True,1)
	
	Can.Invalidate
	Can.Release
	Return P
End Sub

Private Sub CreaLabel(EventN As String, Text As String, Text_Color As Int, ColorB As Int,Size As Int, Bold As Boolean) As B4XView
	Dim L As Label
	L.Initialize(EventN)
	Dim NewLabel As B4XView = L
	
	NewLabel.Text=Text
	NewLabel.Textcolor=Text_Color
	NewLabel.Color=ColorB
	NewLabel.SetTextAlignment("CENTER","CENTER")
	If Bold Then
		NewLabel.Font=xui.CreateDefaultBoldFont(Size)
		Else
		NewLabel.Font=xui.CreateDefaultFont(Size)
	End If
	
	Return NewLabel
End Sub

Private Sub SetExtDate(d As Int, m As Int, y As Int)
	Dim Can As B4XCanvas
	Dim Bmp As B4XView = xui.CreatePanel("")
	Bmp.SetLayoutAnimated(0,0,0,400dip,400dip)
	Can.Initialize(Bmp)
	Can.DrawRect(Can.TargetRect,Color,True,1)
	Can.DrawText(NomeMese(M),210dip,80dip,xui.CreateDefaultBoldFont(60),TextColor,"CENTER")
	Can.DrawText(d,200dip,260dip,xui.CreateDefaultBoldFont(180),TextColor,"CENTER")
	Can.DrawText(y,200dip,350dip,xui.CreateDefaultBoldFont(60),TextColor,"CENTER")
	Can.Invalidate
	
	#if B4J
		'PanelExternal.RemoveAllViews
		Dim Bm As B4XBitmap = Can.CreateBitmap.Resize(PanelExternal.Width,PanelExternal.Height,False)
		CanPanelExternal.DrawBitmap(Bm,CanPanelExternal.TargetRect)
		CanPanelExternal.Invalidate
	#ELSE IF B4A
		PanelExternal.SetBitmap(Can.CreateBitmap.Resize(PanelExternal.Width,PanelExternal.Height,False))
	#ELSE IF B4I
		'PanelExternal.RemoveAllViews
		Dim Bm As Bitmap = Can.CreateBitmap.Resize(PanelExternal.Width,PanelExternal.Height,False)
		CanPanelExternal.Initialize(PanelExternal)
		CanPanelExternal.DrawBitmap(Bm,CanPanelExternal.TargetRect)
		CanPanelExternal.Invalidate
	#End If
	
	Can.Release
End Sub

Private Sub SetTextDate(d As Int, m As Int, y As Int)
	'Dim Bmp As B4XView = xui.CreatePanel("")
	'PanelExternal.RemoveAllViews
	Dim Rec As B4XRect 
	Rec.Initialize(CanPanelExternal.TargetRect.Left+1dip,CanPanelExternal.TargetRect.Top+1dip,CanPanelExternal.TargetRect.Right-4dip,CanPanelExternal.TargetRect.Bottom-2dip)
	Dim P As B4XPath
	P.InitializeRoundedRect(Rec,CornerRadius)
	CanPanelExternal.DrawPath(P,Color,True,1dip)
	P.InitializeRoundedRect(Rec,CornerRadius)
	CanPanelExternal.DrawPath(P,CornerColor,False,1dip)
	CanPanelExternal.DrawText(d & "-" & NomeMese(M).SubString2(0,3) &  "-" & y,mBase.Width/2,mBase.Height/2+5dip,xui.CreateDefaultBoldFont(TextSize),TextColor,"CENTER")
	CanPanelExternal.Invalidate
End Sub

#End Region

#Region Traduci

private Sub NomeGiorno(D As Int) As String
	Dim L_it As List = Array As String ("D","L","M","M","G","V","S")
	Dim L_en As List = Array As String ("S","M","T","W","T","F","S")
	Dim L_es As List = Array As String ("D","L","M","M","J","V","S")
	Dim L_fr As List = Array As String ("D","L","M","M","J","V","S")
	Dim L_de As List = Array As String ("S","M","D","M","D","F","S")
	Dim L_pt As List = Array As String ("D","S","T","Q","Q","S","S")
	Dim L_ru As List = Array As String ("В","П","В","С","Ч","П","С")
	Dim L_ko As List = Array As String ("일","월","화","수","목","금","토")
	Dim S As String
	
	If Lingua.StartsWith("it") Then
		S=L_it.Get(d)
	Else If Lingua.StartsWith("fr") Then
		S=L_fr.Get(d)
	Else If Lingua.StartsWith("ru") Then
		S=L_ru.Get(d)
	Else If Lingua.StartsWith("es") Then
		S=L_es.Get(d-1)
	Else If Lingua.StartsWith("de") Then
		S=L_de.Get(d)
	Else If Lingua.StartsWith("pt") Then
		S=L_pt.Get(d)
	Else If Lingua.StartsWith("ko") Then
		S=L_ko.Get(d)
	Else
		S=L_en.Get(d)
	End If
	
	Return S
End Sub

private Sub NomeMese(M As Int) As String
	Dim L_it As List = Array As String ("Gennaio","Febbraio","Marzo","Aprile","Maggio","Giugno","Luglio","Agosto","Settembre","Ottobre","Novembre","Dicembre")
	Dim L_en As List = Array As String ("January","February","March","April","May","June","July","August","September","October","November","December")
	Dim L_fr As List = Array As String ("Janvier","Février","Mars","Avril","mai","Juin","Juillet","Août","Septembre","Octobre","Novembre","Décembre")
	Dim L_ru As List = Array As String ("Январь" , "Февраль" , "Март","Апрель" , "Май" , "Июнь" , "Июль" , "Август" , "Сентябрь" , "Октябрь" , "Ноябрь" , "Декабрь")
	Dim L_es As List = Array As String ("Enero" , "Febrero" , "Marcha","abril" , "puede" , "Junio​​" , "Julio" , "agosto" , "Septiembre" , "Octubre" , "noviembre" , "diciembre")
	Dim L_de As List = Array As String ("Januar", "Februar", "März" , "April" , "Mai" , "June" , "Juli" , "August" , "September" , "October" , "November" , "December")
	Dim L_pt As List = Array As String ("Janeiro" , "fevereiro" , "March", "Abril" , "pode" , "June" , "Julho" , "August" , "September" , "Outubro" , "November", "dezembro")
	Dim L_ko As List = Array As String ("1월","2월","3월", "4월", "5월", "6월", "7월", "8월", "9월", "10월", "11월", "12월")
	Dim S As String

	If Lingua.StartsWith("it") Then
		S=L_it.Get(M-1)
	Else If Lingua.StartsWith("fr") Then
		S=L_fr.Get(M-1)
	Else If Lingua.StartsWith("ru") Then
		S=L_ru.Get(M-1)
	Else If Lingua.StartsWith("es") Then
		S=L_es.Get(M-1)
	Else If Lingua.StartsWith("de") Then
		S=L_de.Get(M-1)
	Else If Lingua.StartsWith("pt") Then
		S=L_pt.Get(M-1)
	Else If Lingua.StartsWith("ko") Then
		S=L_ko.Get(M-1)
	Else
		S=L_en.Get(M-1)
	End If
	
	Return S
End Sub

private Sub Lingua As String
	#IF B4A
		'Dim r As Reflector
		'r.Target = r.RunStaticMethod("java.util.Locale", "getDefault", Null, Null)
		'Return r.RunMethod("getLanguage")
		Return "it"
	#ELSE IF B4I
		Dim no As NativeObject
		Return no.Initialize("NSLocale").RunMethod("preferredLanguages", Null).RunMethod("objectAtIndex:", Array(0)).AsString
	#ELSE IF B4J
		Return "it"
	#END IF
End Sub
#End Region


#Region Rotate

	Public Sub Rotate(AngleX As Float, AngleY As Float , AngleZ As Float)
	#IF B4A
		Dim jo = mBase As JavaObject
		Dim Px As Float = mBase.Width/2
		Dim Py As Float = mBase.Height/2
		Dim dist As Float = jo.RunMethod("getCameraDistance", Null)
		dist = 1280 * Density '5120
				
		jo.RunMethod("setCameraDistance",Array(dist))
		jo.RunMethod("setPivotX", Array As Object(Px))
		jo.RunMethod("setPivotY", Array As Object(Py))
		jo.RunMethod("setRotationX", Array As Object(AngleX))
		jo.RunMethod("setRotationY", Array As Object(AngleY))
		jo.RunMethod("setRotation", Array As Object(AngleZ))
	#ELSE IF B4I
		Dim no As NativeObject = Me
		Dim X As Int = AngleX
		Dim Y As Int = AngleY
		Dim Z As Int = AngleZ
		no.RunMethod("rotateView::::",Array(mBase, X,Y,Z))
	#End If
	End Sub

	#if OBJC
	- (void)rotateView:(UIView*)mView :(NSInteger)mAngleX :(NSInteger)mAngleY :(NSInteger)mAngleZ  { 
	    //Apply transformation to the PLANE
	    CATransform3D t = CATransform3DIdentity;
	    //Add the perspective!!!
	    t.m34 = 1.0/ -500;    // Play with this for depth changes
	    t = CATransform3DRotate(t, mAngleX * M_PI / 180.0f, 1, 0, 0);
	    t = CATransform3DRotate(t, mAngleY * M_PI / 180.0f, 0, 1, 0);
	    t = CATransform3DRotate(t, mAngleZ * M_PI / 180.0f, 0, 0, 1);
	    mView.layer.transform = t;
	}

	#End If

#End Region
